library Combin;

////////////////////////////////////////////////////////////////////////////////
//                                                                            //
//                                              //
//                               COMBIN v.1.00                                //
//                                                                            //
// :  ..                                                        //
// sadovoya@mtu-net.ru                                                        //
// sadovoya.narod.ru                                                          //
// sintreseng.narod.ru                                                        //
//                                                                            //
//                                2006 .                              //
////////////////////////////////////////////////////////////////////////////////

uses
  SysUtils,
  Classes;

{$R *.res}

Type
  TKArray = Array of Integer;

////////////////////////////////////////////////////////////////////////////////
//                                                                            //
//                                                      //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////

function Product(m,n: Integer): Extended;
//   234..
//  m  n  
var I,Imin,Imax: Integer;
begin
  If ((n<0) or (m<0)) then
     Raise Exception.Create('Product Error#1 - NEGATIVE_ARGUMENTS');
  If (n = m) then
     Raise Exception.Create('Product Error#2 - EQUAL_ARGUMENTS');
  If ((n=0) or (m=0)) then Result:=0;
  Result:=1;
  If (m >n) then begin Imax:=m; Imin:=n; end
          else begin Imax:=n; Imin:=m; end;
  try
  For I:=Imin to Imax do Result:=Result*I;
  except
    Raise Exception.Create('Product Error#3 - OWERFLOW');
  end;
end;

function Factor(n: Integer): Extended;
// 
begin
  If ((n=0) or (n=1)) then Result:=1 else Result:=Product(1,n);
end;

function PowerIntAllPosit(n:integer; x:extended):extended;
//     
var I: Integer;
begin
  If ((n<0) or (x<0)) then
    Raise Exception.Create('PowerIntAllPosit Error#1 - NEGATIVE_ARGUMENTS');
  If (x=0) then begin Result:=1; exit; end;
  Result:=1;
  try
  If n >= 1 then For I:=1 to n do Result:=Result*x else Result:=1;
  except
    Raise Exception.Create('PowerIntAllPosit Error#2 - OWERFLOW');
  end;
end;

////////////////////////////////////////////////////////////////////////////////
//                                                                            //
//                                                             //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////

function PbyM(m: Integer): Extended; StdCall;
//     m
begin
  Result:=factor(m);
end;

function AbyMfromN(m,n: Integer): Extended; StdCall;
//     m  n 
begin
  If m>n then
    Raise Exception.Create('AbyMfromN Error. m > n');
  If m=0 then Result:=1
    else If m=1 then Result:=n
      else Result:=Product(n,(n-m+1));
end;

function CbyMfromN(m,n: Integer): Extended; StdCall;
//     m  n 
begin
  If m>n then
    Raise Exception.Create('CbyMfromN Error. m > n');
  If  ((m>=n-m)and(n>(m+1))) then Result:= Product(n,m+1)/factor(n-m)
    else Result:= AbyMfromN(m,n)/factor(m);
end;

function A_byMfromN(m,n: Integer): Extended; StdCall;
//     m 
//   n 
begin
  Result:=PowerIntAllPosit(m,n);
end;

function PbyKs(k: TKArray): Extended; StdCall;
//   
Var Num,I: Integer;
    ksum, kmax, Imax: Integer;
    Sign: Boolean;
begin
  Num:=Length(k);
  Sign:=True;
  For I:=0 to (Num-1) do If k[I]<0 then Sign:=False;
  If not Sign then Raise Exception.Create('PbyKs Error#1 - NEGATIVE_ARGUMENTS');
  If Num=1 then begin Result:=1; exit; end;
  ksum:=0;
  kmax:=0;
  Imax:=0;
  For I:=0 to (Num-1) do
  begin
    ksum:=Ksum+k[I];
    If (k[I]>=kmax) then begin kmax:=k[I]; Imax:=I; end;
  end;
  Result:=1;
  try
  For I:=0 to (Num-1) do If (I<>Imax) then Result:=Result*factor(k[I]);
  Result:=Product(ksum,kmax+1)/Result;
  except
    Raise Exception.Create('PbyKs Error#2 - OWERFLOW');
  end;
end;

function C_byMfromN(m,n: Integer): Extended; StdCall;
//     m 
//   n 
begin
  If ((m=0) or (n=1)) then begin Result:=1; Exit; end;
  Result:=factor(m+n-1)/factor(m)/factor(n-1);
end;

////////////////////////////////////////////////////////////////////////////////
//                               //
////////////////////////////////////////////////////////////////////////////////

exports
  PbyM,
  AbyMfromN,
  CbyMfromN,
  A_byMfromN,
  PbyKs,
  C_byMfromN;
 
begin
end.
